/*
    Serial link emulation
    This file is part of the zBoy project
    Copyright (C) Mateusz Viste 2010


    FF02 is the serial control address
      Bit 7 - if set, the game wants to interact with serial link
      Bit 0 - Clock source selection (0 = external   1 = internal)

    FF01 is the serial data buffer (for in & out operations)
*/

//#MACRO CheckSerialLink()
inline void CheckSerialLink() {  // For now, this procedure just fakes a Serial GB interface which is connected nowhere
  if (NetPlay == 0) {  // No net player
      if ((IoRegisters[0xFF02] & 128) > 0) {    // The game tries to send some stuff out
        if ((IoRegisters[0xFF02] & 1) > 0) {  // If external clock is selected, ignore, otherwise let's see
          //printf("%08d cycles: %c\n", TotalCycles, IoRegisters[0xFF01]); // for DEBUG purpose, you can print out to console
          IoRegisters[0xFF01] = 0xFF;    // FF means no data has been received
          IoRegisters[0xFF0F] = (IoRegisters[0xFF0F] | 8);   // When serial handling done, request serial interrupt (INT 58), via bit 3 of FF0F
        }
        IoRegisters[0xFF02] = (IoRegisters[0xFF02] & 127);   // Reset the bit 7 of FF02 (see page 31 of GameBoy CPU manual)
      }
    } else {   // Net player...
/*      #IFDEF NETPLAYSUPPORT ' Only if enabled at compile time
        IF (IoRegisters(&hFF02) AND &b10000000) > 0 THEN  ' The game tries to send some stuff out
          NetSendByteBuff = IoRegisters(&hFF01)   ' shift $FF01 out of the serial link
          IF (IoRegisters(&hFF02) AND &b00000001) > 0 THEN  ' If external clock is selected, wait for something to come in
            DO : LOOP UNTIL NetPollingState = 1  ' wait for something to come in
          END IF
          IF NetPollingState = 1 THEN  ' We have something in da buffer
              IoRegisters(&hFF01) = NetRecvByteBuff
              NetPollingState = 0
              IoRegisters(&hFF0F) = (IoRegisters(&hFF0F) OR &b00001000) ' When serial handling done, request serial interrupt (INT 58), via bit 3 of FF0F
            ELSE
              IoRegisters(&hFF01) = &hFF   ' FF means no data has been received
          END IF

          IoRegisters(&hFF02) = (IoRegisters(&hFF02) AND &b0111111) ' Reset the bit 7 of FF02 (see page 31 of GameBoy CPU manual)
        END IF
      #ENDIF  */
  }
}
//#ENDMACRO
